//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#pragma hdrstop

#include "HPelota.h"

#pragma package(smart_init)
//---------------------------------------------------------------------------
//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall THebraPelota::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------
__fastcall THebraPelota::THebraPelota(TPaintBox *PaintBox)
        : TThread(false)
{
  Priority        = tpNormal;
  FreeOnTerminate = false;        // FreeOnTerminate & WaitFor
                                  // no pueden usarse a la vez en C++Builder 6



  Pelota = new TPelota (
    PaintBox,
    (TColor)(random(0xFF)|
            (random(0xFF)*0x100)|
            (random(0xFF)*0x10000)),
    random(PaintBox->Width),
    random(PaintBox->Height),
    random(40)+1,
    TDireccion((random(2)+1) |
               (random(2)+1)*4));
}

__fastcall THebraPelota::~THebraPelota(void)
{
  delete Pelota;
};

//---------------------------------------------------------------------------
void __fastcall THebraPelota::Execute()
{
  // Cdigo de la Hebra

  while (!Terminated) {

        try {
           Pelota->Mover();
        } catch (Exception &error) {
           // Error al acceder al Canvas: ShowMessage(error.Message);
        }

        Sleep(10);
  }
}
//---------------------------------------------------------------------------
